*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\FORUMHMG\FORUMHMG.PRG
*+
*+    Copyright(C) 1983-2022 by Auge & Ohr
*+
*+    Functions: Init Procedure MainInit()
*+               Procedure MAIN()
*+               Static Procedure CreateSetup()
*+               Static Procedure CreateIndex()
*+               Static Procedure CreateForumDBF()
*+               Static Procedure CreateStripHTML()
*+               Static Procedure CreateNotUser()
*+               Static Procedure CreateColor()
*+               Static Procedure CheckDBF()
*+               Static Procedure CheckForumDir()
*+               Static Procedure LoadConfig()
*+               Static Procedure DoInit()
*+               Static Procedure BeforeRelease()
*+               Static Procedure FillComboForum()
*+               Static Procedure Forum_Store()
*+               Static Procedure Forum_Replace()
*+               Static Procedure FindReplRTFProc()
*+               Static Procedure DoCleanBody()
*+               Static Procedure DoChangeForum()
*+               Static Procedure HelpFile()
*+               Static Procedure DoUserInfo()
*+               Static Procedure HeadSort()
*+               Static Procedure DoOpenCombo()
*+               Static Procedure DoNextForum()
*+               Static Procedure DoSaveINI()
*+               Static Procedure TestLog()
*+               Static Procedure ListThreadNumber2Clip()
*+               Procedure DoLink()
*+               Procedure ChangeFilter()
*+               Procedure DoBrowseSetFocus()
*+               Procedure DoBrowseRefresh()
*+               Procedure RTF2Clip()
*+               Procedure ShowMemoCODE()
*+               Procedure SetTransparency()
*+               Procedure DoReNewMsg()
*+               Procedure SetNewCursor()
*+               Function SHELLOPENFILE()
*+               Function CalcPos()
*+               Function Net_Lock()
*+               Function Net_Append()
*+               Function Net_Use()
*+               Function IsInternet()
*+
*+       Tables: USE (cFile_dbf) EXCLUSIVE VIA "DBFCDX"
*+               USE (cFile_dbf) EXCLUSIVE ALIAS (cAlias) VIA "DBFCDX"
*+               USE (cFile_dbf) VIA "DBFCDX"
*+               USE (cFile_dbf) ALIAS (cAlias) VIA "DBFCDX"
*+
*+    Reformatted by Click! 2.05.40 on Oct-6-2022 at  3:32 am
*+
*+--------------------------------------------------------------------

#INCLUDE "HMG.CH"
#INCLUDE "Common.CH"
#include "Dbstruct.ch"
#INCLUDE "DLL.CH"
#INCLUDE "COLOR.CH"

#define SE_ERR_NOASSOC                 31
#define RadioSpace                     80

#define WM_CLOSE                       0x0010
#define WM_QUIT                        0x0012

#define LVIS_FOCUSED                   0x1
#define LVIS_SELECTED                  0x2
#define LVIS_CUT                       0x4
#define LVIS_DROPHILITED               0x8
#define LVIS_GLOW                      0x10
#define LVIS_ACTIVATING                0x20
#define LVIS_OVERLAYMASK               0xf00
#define LVIS_STATEIMAGEMASK            0xF000

#define EM_SETWORDBREAKPROC            0x00D0

#xtranslate DllCall => HMG_CallDLL

REQUEST DBFCDX
REQUEST DBFNTX

REQUEST HB_CODEPAGE_BG866
REQUEST HB_CODEPAGE_BGISO
REQUEST HB_CODEPAGE_BGMIK
REQUEST HB_CODEPAGE_BGWIN
REQUEST HB_CODEPAGE_CS852
REQUEST HB_CODEPAGE_CS852C                                            // not in Grid
REQUEST HB_CODEPAGE_CSISO
REQUEST HB_CODEPAGE_CSKAMC                                            // not in Grid
REQUEST HB_CODEPAGE_CSWIN
REQUEST HB_CODEPAGE_DE850
REQUEST HB_CODEPAGE_DE850M                                            // not in Grid
REQUEST HB_CODEPAGE_DEISO                                             // not in Grid
REQUEST HB_CODEPAGE_DEWIN
REQUEST HB_CODEPAGE_DK865                                             // not in Grid
REQUEST HB_CODEPAGE_EL437                                             // not in Grid
REQUEST HB_CODEPAGE_EL737
REQUEST HB_CODEPAGE_ELISO                                             // not in Grid
REQUEST HB_CODEPAGE_ELWIN
REQUEST HB_CODEPAGE_EN
REQUEST HB_CODEPAGE_ES850
REQUEST HB_CODEPAGE_ES850C                                            // not in Grid
REQUEST HB_CODEPAGE_ES850M                                            // not in Grid
REQUEST HB_CODEPAGE_ESISO                                             // not in Grid
REQUEST HB_CODEPAGE_ESMWIN
REQUEST HB_CODEPAGE_ESWIN
REQUEST HB_CODEPAGE_FI850                                             // not in Grid
REQUEST HB_CODEPAGE_FR850
REQUEST HB_CODEPAGE_FR850C                                            // not in Grid
REQUEST HB_CODEPAGE_FR850M                                            // not in Grid
REQUEST HB_CODEPAGE_FRISO                                             // not in Grid
REQUEST HB_CODEPAGE_FRWIN                                             // not in Grid
REQUEST HB_CODEPAGE_HE862                                             // not in Grid
REQUEST HB_CODEPAGE_HEWIN                                             // not in Grid
REQUEST HB_CODEPAGE_HR646
REQUEST HB_CODEPAGE_HR852
REQUEST HB_CODEPAGE_HRISO                                             // not in Grid
REQUEST HB_CODEPAGE_HRWIN
REQUEST HB_CODEPAGE_HU852
REQUEST HB_CODEPAGE_HU852C
REQUEST HB_CODEPAGE_HUISO
REQUEST HB_CODEPAGE_HUWIN
REQUEST HB_CODEPAGE_IS850                                             // not in Grid
REQUEST HB_CODEPAGE_IS861                                             // not in Grid
REQUEST HB_CODEPAGE_IT437
REQUEST HB_CODEPAGE_IT850
REQUEST HB_CODEPAGE_IT850M                                            // not in Grid
REQUEST HB_CODEPAGE_ITISB
REQUEST HB_CODEPAGE_ITISO
REQUEST HB_CODEPAGE_ITWIN                                             // not in Grid
REQUEST HB_CODEPAGE_LT775                                             // not in Grid
REQUEST HB_CODEPAGE_LTWIN
REQUEST HB_CODEPAGE_NL850                                             // not in Grid
REQUEST HB_CODEPAGE_NL850M                                            // not in Grid
REQUEST HB_CODEPAGE_NO865                                             // not in Grid
REQUEST HB_CODEPAGE_PL852
REQUEST HB_CODEPAGE_PLISO
REQUEST HB_CODEPAGE_PLMAZ
REQUEST HB_CODEPAGE_PLWIN
REQUEST HB_CODEPAGE_PT850
REQUEST HB_CODEPAGE_PT860                                             // not in Grid
REQUEST HB_CODEPAGE_PTISO
REQUEST HB_CODEPAGE_RO852                                             // not in Grid
REQUEST HB_CODEPAGE_ROISO                                             // not in Grid
REQUEST HB_CODEPAGE_ROWIN                                             // not in Grid
REQUEST HB_CODEPAGE_RU1251
REQUEST HB_CODEPAGE_RU866
REQUEST HB_CODEPAGE_RUISO                                             // not in Grid
REQUEST HB_CODEPAGE_RUKOI8
REQUEST HB_CODEPAGE_SK852
REQUEST HB_CODEPAGE_SK852C                                            // not in Grid
REQUEST HB_CODEPAGE_SKISO
REQUEST HB_CODEPAGE_SKKAMC                                            // not in Grid
REQUEST HB_CODEPAGE_SKWIN
REQUEST HB_CODEPAGE_SL646                                             // not in Grid
REQUEST HB_CODEPAGE_SL852
REQUEST HB_CODEPAGE_SLISO
REQUEST HB_CODEPAGE_SLWIN
REQUEST HB_CODEPAGE_SR646                                             // not in Grid
REQUEST HB_CODEPAGE_SR646C                                            // not in Grid
REQUEST HB_CODEPAGE_SRWIN
REQUEST HB_CODEPAGE_SV437C
REQUEST HB_CODEPAGE_SV850
REQUEST HB_CODEPAGE_SV850M                                            // not in Grid
REQUEST HB_CODEPAGE_SVISO
REQUEST HB_CODEPAGE_SVWIN
REQUEST HB_CODEPAGE_TR857
REQUEST HB_CODEPAGE_TRISO                                             // not in Grid
REQUEST HB_CODEPAGE_TRWIN
REQUEST HB_CODEPAGE_UA1125                                            // not in Grid
REQUEST HB_CODEPAGE_UA1251
REQUEST HB_CODEPAGE_UA866
REQUEST HB_CODEPAGE_UAKOI8
REQUEST HB_CODEPAGE_UTF16LE                                           // not in Grid
REQUEST HB_CODEPAGE_UTF8
REQUEST HB_CODEPAGE_UTF8EX

STATIC cVersion := "v0.4.8"

MEMVAR _HMG_SYSDATA
MEMVAR cWorkPath, cWorkURL, cWorkSign
MEMVAR cWorkKeyWord, cWorkAuthor, lNotUser
MEMVAR cWorkPhpbb, aWorkPhpbb, aHTMLsign, aCODEsign, lDebug, lTranslate
MEMVAR BGcolor, BFcolor, BGfont, FGfont, nTransparent, cTranslateCP

// *********************************************************************
//
//  07.08.2022   v0.0.4 seperate Folder
//  08.08.2022   v0.0.5 HMG CATEGORY.DBF
//  09.08.2022   v0.0.6 seperate Modul DLFORUM.PRG, DYNAMICBACKCOLOR
//  10.08.2022   v0.0.7 Form : Download RANGE, Filter Keyword/Author
//  11.08.2022   v0.0.8 SHOWMEMO.PRG, better "analyze"
//  12.08.2022   v0.0.9 Progressbar / Time left
//  13.08.2022   v0.1.0 CONFIG.INI, Net_Append(), Net_Lock()
//                      Network multi Instanze possibe for download
//  14.08.2022   v0.1.1 new Concept no Category
//
//               v0.1.2 Release 1st Version
//
//               v0.1.3 working with Xbase++ Forum. Fivewin have other Date/Time
//  15.08.2022   v0.1.4 FiveWin Forum
//               v0.1.5 FiveWin "Strip" CODE {} [] &&
//
//  16.08.2022   v0.1.6 2nd Release
//
//  29.08.2022   v0.1.7 new Concept, Translate Body
//  30.08.2022   v0.1.8 more "strip" HTML Code from Body, ONHEADCLICK
//  31.08.2022   v0.1.9 change RADIO Button. ADD Index TAG "MSGDATE"
//  01.09.2022   v0.2.0 DUPE Check before Step 5 in StripHTMLCode()
//  02.09.2022   v0.2.1 "Not User" F9 in DoSetFilterTo()
//  03.09.2022   v0.2.2 Windows for FORUMDIR.DBF, HTMLSIGN.DBF, NOTUSER.DBF
//                      COLOR.DBF and BGfont, FGfont with Colorpicker
//                      Save CONFIG.INI (more Parameter)
//  04.09.2022   v0.2.3 when Translate Window is active it will automatic work
//
//               v0.2.4 RELEASE Source
//
//  05.09.2022   v0.2.5 BUG MsgNo when not "in Order" -> DoCleanBody()
//  06.09.2022   v0.2.6 DoReNewMsg() : all Message of same Thread
//  07.09.2022   v0.2.7 DoMethod( "FORUM", "Browse_Main", "SetFocus" )
//  08.09.2022   v0.2.8 Forum Combobox ONENTER -> ON CLOSEUP
//                      move "Transparency" into ShowMemo
//  09.09.2022   v0.2.9 DLALLCOD.PRG : get all CODE again
//  10.09.2022   v0.3.0 Layout/Resize for all "Edit" Window
//  11.09.2022   v0.3.1 CheckForumDir(), SnapToCtrl()
//  12.09.2022   v0.3.2 DownloadRange() change Index TAG "MSGDATE" -> "DUPECHECK"
//  13.09.2022   v0.3.3 EofBody(@cBody)
//  14.09.2022   v0.3.4 "DOS Error 32" when App "hang" in Tasklist
//  15.09.2022   v0.3.5 Net_Use()
//                      hb_Translate( oError:Description, cTranslateCP+"WIN" )
//  16.09.2022   v0.3.6 RichEdit_Body : HSCROLL .T. -> WordBreak RTF Width
//                      Debug Files -> GetThreadFileName(cWorkPath, nThreadNo )
//  17.09.2022   v0.3.7 Option /T -> Toolbar for Touchpad
//
//                      3rd Release
//
//  18.09.2022   v0.3.8 more Cursor (WAIT) and Icon for SayBarText()
//  19.09.2022   v0.3.9 DoErrorLog() -> ListLog( aError )
//  20.09.2022   v0.4.0 FiveWin : remove CHR(194) and CHR(160) in CODE
//  21.09.2022   v0.4.1 after CODE Rest of BODY is missing
//  22.09.2022   v0.4.2 IsInternet()
//  23.09.2022   v0.4.3 Translate FromClipBoard()
//  24.09.2022   v0.4.4 new Forum "Deskmodder" (German Hardware Forum)
//  28.09.2022   v0.4.5 IsInternet() on other Place
//  03.10.2022   v0.4.6 ReleaseAllWindows()
//  04.10.2022   v0.4.7 lTranslate
//
//  06.10.2022   v0.4.8 RELEASE Source and EXE
//
// *********************************************************************

*+--------------------------------------------------------------------
*+
*+    Init Procedure MainInit()
*+
*+--------------------------------------------------------------------
*+
INIT PROCEDURE MainInit()

LOCAL cTitle  := "phpBB Forum Grabber " + cVersion
LOCAL hWndDlg := FindWindowEx(,,, cTitle )
   IF !( hWndDlg == 0 )
      MsgInfo( "phpBB Forum Grabber " + cVersion + " is running ..." )
      IF ISMINIMIZED( hWndDlg )
         RESTORE( hWndDlg )
      ENDIF
      SetForegroundWindow( hWndDlg )
      BringWindowToTop( hWndDlg )
      ShowWindow( hWndDlg, 1 )
      UpdateWindow( hWndDlg )
      QUIT                                                            // It is a second instance. Bye Bye
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure MAIN()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE MAIN()

LOCAL i, iMax := PCOUNT()
LOCAL aWidths  := { 100, 200, 60, 60 }
LOCAL aHeader  := { "Author", "Topic", "Date", "Time" }
LOCAL aFields  := { "AUTHOR", "TOPIC", "TDATE", "TTIME" }
LOCAL cDBF     := "FORUM.DBF"
LOCAL cCDX     := "FORUM.CDX"
LOCAL cHome    := hb_DirBase()
LOCAL nButtons := 0
LOCAL nDiff    := 0
LOCAL xValue

   //------------------------------ CONFIG.INI --------------------------
LOCAL cRow         := "0"
LOCAL cCol         := "0"
LOCAL cWidth       := "1024"
LOCAL cHeight      := "800"
LOCAL cMemoRow     := "0"
LOCAL cMemoCol     := "0"
LOCAL cMemoWidth   := "1024"
LOCAL cMemoHeight  := "800"
LOCAL cFontSize    := "16"
LOCAL cPhPBB       := "HMG Forum"
LOCAL cTLrow       := "0"
LOCAL cTLcol       := "1024"
LOCAL cTLWidth     := "1024"
LOCAL cTLHeight    := "800"
LOCAL cTransparent := "85"
   //--------------------------------------------------------------------

PRIVATE lDebug       := .F.
PRIVATE cWorkPath    := hb_DirBase()
PRIVATE cWorkURL     := "https://www.hmgforum.com/viewtopic.php"
PRIVATE cWorkSign    := "?&t="
PRIVATE BGfont       := BLACK                                         // WHITE
PRIVATE FGfont       := CYAN                                          // BLACK
PRIVATE BGcolor      := { || IF( SUBSTR( FIELD->TOPIC, 1, 3 ) = "Re:", BGfont, GRAY ) }
PRIVATE BFcolor      := { || IF( SUBSTR( FIELD->TOPIC, 1, 3 ) = "Re:", FGfont, WHITE ) }
PRIVATE aWorkPhpbb   := {}
PRIVATE aHTMLsign    := {}
PRIVATE aCODEsign    := {}
PRIVATE nTransparent := 85
PRIVATE lNotUser     := .F.
PRIVATE cTranslateCP := "DE"
PRIVATE cWorkKeyWord, cWorkAuthor, cWorkPhpbb, lTranslate := .T.

   SET DATE GERMAN
   SET CENTURY ON
   SET EPOCH TO YEAR( DATE() ) - 50

   //    SET MULTIPLE OFF                                                   // unused
   SET BROWSESYNC ON                                                  // sync BROWSE with DBF ?
   SET AUTOSCROLL ON                                                  // virtual dimensioned windows scrollbars
   SET NAVIGATION EXTENDED                                            // ENTER -> TAB
   SET DELETED ON

   IF .NOT. IsInternet()
      SayBarText(, "ICOSTOP" )
   ENDIF

   FOR i := 1 TO iMax
      xValue := UPPER( PValue( i ) )
      DO CASE
         CASE SUBSTR( xValue, 1, 2 ) = "/D"
            lDebug := .T.

         CASE SUBSTR( xValue, 1, 2 ) = "/T"
            nButtons := 14
            nDiff := 26

      ENDCASE
   NEXT

   IF lDebug = .T.
      SET ALTER TO "_LOGIT2.TXT"
      ondummy( "Start : " + TIME() )
   ENDIF

   LoadConfig( @cRow, @cCol, @cWidth, @cHeight, @cMemoRow, @cMemoCol, @cMemoWidth, @cMemoHeight, @cFontSize, @cPhPBB, @cTLrow, @cTLcol, @cTLWidth, @cTLHeight, @cTranslateCP, @cTransparent )
   nTransparent := VAL( cTransparent )

   SELECT 5
   IF !FILE( cHome + "COLOR.DBF" )
      CreateColor( cHome + "COLOR.DBF" )
   ENDIF
   // USE ( cHome + "COLOR.DBF" ) EXCLUSIVE VIA "DBFCDX"
   IF Net_Use( cHome + "COLOR.DBF", .T. )
      BGfont := NumColor2RGB( FIELD->BACKGROUND )
      FGfont := NumColor2RGB( FIELD->FOREGRAUND )
      CLOSE
   ELSE
      MsgInfo( "Error open DBF", "COLOR.DBF" )
   ENDIF

   SELECT 4
   IF !FILE( cHome + "NOTUSER.DBF" )
      CreateNotUser( cHome + "NOTUSER.DBF" )
   ENDIF

   SELECT 3
   IF !FILE( cHome + "HTMLSIGN.DBF" )
      CreateStripHTML( cHome + "HTMLSIGN.DBF" )
   ENDIF

   SELECT 2
   IF !FILE( cHome + "FORUMDIR.DBF" )
      CreateForumDBF( cHome + "FORUMDIR.DBF" )
   ENDIF
   CheckForumDir( cHome, "FORUMDIR.DBF" )

   SELECT 2
   // USE "FORUMDIR.DBF" EXCLUSIVE VIA "DBFCDX"
   IF Net_Use( "FORUMDIR.DBF", .T. )
      cWorkPath := TRIM( FORUMDIR->LOCALPATH )
      cWorkURL := TRIM( FORUMDIR->FORUMURL )
      cWorkSign := TRIM( FORUMDIR->THREADSIGN )
      CLOSE
   ELSE
      MsgInfo( "Error open DBF", "FORUMDIR.DBF" )
   ENDIF

   SELECT 1
   IF !FILE( cWorkPath + cDBF )
      CreateSetup( cWorkPath + cDBF )
   ENDIF
   CheckDBF( cWorkPath, cDBF )

   IF !FILE( cWorkPath + cCDX )
      CreateIndex( cWorkPath + cDBF, cWorkPath + cCDX )
   ENDIF

   // USE (cWorkPath+cDBF) ALIAS "FORUM" VIA "DBFCDX"
   IF Net_Use( cWorkPath + cDBF, .F., "FORUM" )
      SET INDEX TO ( cWorkPath + cCDX )
      ORDSETFOCUS( "MSGDATE" )
      GO BOTTOM
   ELSE
      MsgInfo( "Error open DBF", cWorkPath + cDBF )
   ENDIF

   DEFINE WINDOW FORUM AT 0, 0 ;
         WIDTH 800 HEIGHT 600 ;
         TITLE "phpBB Forum Grabber " + cVersion ;
         ICON "AUGEOHR" ;
         ON INIT DoInit( ThisWindow.Name, cRow, cCol, cWidth, cHeight, cPhPBB, cDBF, cCDX ) ;
         ON RELEASE BeforeRelease() ;
         ON INTERACTIVECLOSE ReleaseAllWindows() ;                    //  BeforeRelease() ;
         ON SIZE LayoutAdjust( ThisWindow.Name, 800, 600 ) ;
         ON MAXIMIZE LayoutAdjust( ThisWindow.Name, 800, 600 ) ;
         BACKCOLOR BGfont

      DEFINE STATUSBAR FONT "Arial" SIZE 11
         STATUSITEM "press F1 for help"
         STATUSITEM "" WIDTH 24 ACTION DoErrorLog( "LISTBOX" )
         DATE WIDTH 100
         CLOCK WIDTH 100
      END STATUSBAR

      DEFINE MAIN MENU
         DEFINE POPUP "&Menu"
            MENUITEM "&Save CONFIG.INI" IMAGE "MYSAVE" ACTION DoSaveINI( cMemoRow, cMemoCol, cMemoWidth, cMemoHeight, cFontSize, cWorkPhpbb, cTLrow, cTLcol, cTLWidth, cTLHeight, cTranslateCP, cTransparent )
            SEPARATOR
            MENUITEM "E&xit" IMAGE 'MYEXIT' ACTION ReleaseAllWindows()                                                                      // FORUM.Release
         END POPUP

         DEFINE POPUP "&Database"
            MENUITEM "&phpBB" IMAGE "MYPHPBB" ACTION EDIT_PHPBB( nButtons )
            SEPARATOR
            MENUITEM "&HTML Sign" IMAGE "MYHTML" ACTION EDIT_HTMLSIGN( nButtons )
            SEPARATOR
            MENUITEM "&Autor" IMAGE "MYUSER" ACTION EDIT_USER( nButtons )
            SEPARATOR
            MENUITEM "&Color" IMAGE "MYCOLOR" ACTION Setup_Color()
            SEPARATOR
         END POPUP

         DEFINE POPUP "&About"
            MENUITEM "&IP Info" IMAGE 'MYINFO32' ACTION IP_Info()
            SEPARATOR
            MENUITEM "&Mail to author..." IMAGE "MYEMAIL32" ;
                    ACTION ShellExecute( 0, "open", "rundll32.exe", ;
                    "url.dll,FileProtocolHandler " + ;
                    "mailto:Auge_Ohr@Web.DE" + ;
                    "&subject=phpBB%20Forum%20Grabber%20" + cVersion + "%20Feedback:" + ;
                    "&body=Hello%20World",, 1 )
         END POPUP
      END MENU

      DEFINE CONTEXT MENU OF FORUM
         IF nButtons < 1
            MENUITEM "&next Forum                   " IMAGE "MYPHPBB" ACTION DoNextForum( cDBF, cCDX )
            SEPARATOR
            MENUITEM "&Download                                    (F7)" IMAGE "MYGO" ACTION DownloadRange()
            SEPARATOR
            MENUITEM "&re-new this Thread" IMAGE "MYRELOAD" ACTION DoReNewMsg( .T. )
            MENUITEM "re-new ALL C&ODE of Forum" IMAGE "MYALLCODE" ACTION DownloadRenewCode()
            SEPARATOR
            MENUITEM "clean &all from HTML" IMAGE "MYCLEAN32" ACTION DoCleanBody( cDBF, cCDX )
            SEPARATOR
            MENUITEM "SET &Filter                             (CTRL+F)" IMAGE "MYFILTER" ACTION DoSetFilterTo()
            SEPARATOR
         ENDIF
         MENUITEM "&Copy Select to Clipboard" IMAGE "MYCLIP" ACTION RTF2Clip( "BODY" )
         SEPARATOR
         MENUITEM "&Translate MEMO" IMAGE "MYNETWORK" ACTION TranslateMemoFORM( cTLrow, cTLcol, cTLWidth, cTLHeight, cFontSize )
      END MENU

      IF nButtons > 0
         DEFINE TOOLBAR ToolBar_1 OF FORUM BUTTONSIZE VAL( cWidth ) / nButtons, 50 STRICTWIDTH FLAT

            BUTTON MYEXIT ;
                    TOOLTIP "Exit" ;
                    PICTURE "MYEXIT" ;
                    SEPARATOR ;
                    ACTION ReleaseAllWindows()                        // FORUM.Release

            BUTTON MYDUMMY1 ;
                    SEPARATOR ;
                    ACTION NIL

            BUTTON MYPHPBB ;
                    TOOLTIP "next Forum" ;
                    PICTURE "MYPHPBB" ;
                    SEPARATOR ;
                    ACTION DoNextForum( cDBF, cCDX )

            BUTTON MYGO ;
                    TOOLTIP "F7 Download new Message" ;
                    PICTURE "MYGO" ;
                    SEPARATOR ;
                    ACTION DownloadRange()

            BUTTON MYRELOAD ;
                    TOOLTIP "re-new this Thread" ;
                    PICTURE "MYRELOAD" ;
                    ACTION DoReNewMsg( .T. )

            BUTTON MYALLCODE ;
                    TOOLTIP "re-new ALL CODE of Forum" ;
                    PICTURE "MYALLCODE" ;
                    SEPARATOR ;
                    ACTION DownloadRenewCode()

            BUTTON MYDUMMY2 ;
                    SEPARATOR ;
                    ACTION NIL

            BUTTON MYCLEAN32 ;
                    TOOLTIP "clean all from HTML" ;
                    PICTURE "MYCLEAN32" ;
                    SEPARATOR ;
                    ACTION DoCleanBody( cDBF, cCDX )

            BUTTON MYDUMMY3 ;
                    SEPARATOR ;
                    ACTION NIL

            BUTTON MYFILTER ;
                    TOOLTIP "CTRL+F SET Filter" ;
                    PICTURE "MYFILTER" ;
                    SEPARATOR ;
                    ACTION DoSetFilterTo()

            BUTTON MYDUMMY4 ;
                    SEPARATOR ;
                    ACTION NIL

            BUTTON MYCLIPBOARD ;
                    TOOLTIP "Copy Select to Clipboard" ;
                    PICTURE "MYCLIP" ;
                    ACTION RTF2Clip( "BODY" )

            BUTTON MYTRANSLATE ;
                    TOOLTIP "Translate MEMO" ;
                    PICTURE "MYNETWORK" ;
                    ACTION TranslateMemoFORM( cTLrow, cTLcol, cTLWidth, cTLHeight, cFontSize )

            BUTTON MYDUMMY5 ;
                    SEPARATOR ;
                    ACTION NIL

            BUTTON MYABOUT ;
                    TOOLTIP "Mail to author..." ;
                    PICTURE "MYEMAIL32" ;
                    ACTION ShellExecute( 0, "open", "rundll32.exe", ;
                    "url.dll,FileProtocolHandler " + ;
                    "mailto:Auge_Ohr@Web.DE" + ;
                    "&subject=phpBB%20Forum%20Grabber%20" + cVersion + "%20Feedback:" + ;
                    "&body=Hello%20World",, 1 )
         END TOOLBAR
      ENDIF

      DEFINE PROGRESSBAR ProgressBar_1
         ROW 1
         COL 0
         WIDTH 790
         HEIGHT 3
         RANGEMIN 1
         RANGEMAX 100
         VALUE 100
         VISIBLE .F.
         BACKCOLOR BGfont
         FORECOLOR FGfont
      END PROGRESSBAR

      DEFINE BROWSE Browse_Main
         ROW 10 + nDiff
         COL 370
         WIDTH 404
         HEIGHT 530 - 246
         VALUE 0
         WIDTHS aWidths
         HEADERS aHeader
         WORKAREA FORUM
         FIELDS aFields
         FONTNAME "Arial"
         FONTSIZE 11
         ONCHANGE Forum_Store()
         ONHEADCLICK { { || HeadSort( 1 ) }, { || HeadSort( 2 ) }, { || HeadSort( 3 ) }, { || HeadSort( 4 ) } }
         ONLOSTFOCUS DoBrowseSetFocus( .F. )
         VSCROLLBAR .T.
         DYNAMICBACKCOLOR { BGcolor, BGcolor, BGcolor, BGcolor }
         DYNAMICFORECOLOR { BFcolor, BFcolor, BFcolor, BFcolor }
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END BROWSE

      DEFINE COMBOBOX Combo_PhpBB
         ROW 10 + nDiff
         COL 70
         WIDTH 290
         HEIGHT 300
         ITEMS { "" }
         VALUE 1
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         ON LOSTFOCUS DoBrowseSetFocus()
         // ONENTER {|| DoChangeForum( cDBF, cCDX ), DoBrowseSetFocus() }
         ON CLOSEUP { || DoChangeForum( cDBF, cCDX ), DoBrowseSetFocus() }
      END COMBOBOX

      DEFINE RADIOGROUP RadioGroup_1
         ROW 152 + nDiff
         COL 10
         WIDTH 290
         HEIGHT 28
         OPTIONS { '&No Filter', "C &or A", "&Code", "&Attachment" }
         VALUE 1
         FONTNAME "Arial"
         FONTSIZE 11
         ONCHANGE ChangeFilter()
         TABSTOP .T.
         VISIBLE .T.
         SPACING RadioSpace
         BACKCOLOR nil                                                // BGfont
         FONTCOLOR nil                                                // FGfont
         HORIZONTAL .T.
      END RADIOGROUP

      DEFINE BUTTON Button_Link
         ROW 06 + nDiff + IF( nButtons > 0, 2, 0 )
         COL 10
         WIDTH 56
         HEIGHT 30
         ACTION { || IF( SHELLOPENFILE( TRIM( FORUM->LINK ) + "&start=" + LTRIM( STR( FORUM->NOOFMSG ) ) ), nil, MsgInfo( "fail" ) ) }
         CAPTION "&Link"
         TOOLTIP "open URL Link"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
      END BUTTON

      DEFINE TEXTBOX Text_LINK
         ROW 40 + nDiff
         COL 10
         WIDTH 350
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         MAXLENGTH 250
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         VALUE ""
      END TEXTBOX

      DEFINE LABEL Label_TREADNO
         ROW 68 + nDiff
         COL 10
         WIDTH 56
         HEIGHT 24
         VALUE "No"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END LABEL

      DEFINE TEXTBOX Text_TREADNO
         ROW 68 + nDiff
         COL 70
         WIDTH 60
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         MAXLENGTH 6
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         DATATYPE NUMERIC
         VALUE 0
      END TEXTBOX

      DEFINE LABEL Label_FORUM
         ROW 96 + nDiff
         COL 10
         WIDTH 56
         HEIGHT 24
         VALUE "Msg No."
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END LABEL

      DEFINE TEXTBOX Text_NOOFMSG
         ROW 96 + nDiff
         COL 70
         WIDTH 60
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         MAXLENGTH 2
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         DATATYPE NUMERIC
         VALUE 0
      END TEXTBOX

      DEFINE LABEL Label_LIKE
         ROW 124 + nDiff
         COL 10
         WIDTH 56
         HEIGHT 24
         VALUE "Like"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END LABEL

      DEFINE TEXTBOX Text_LIKE
         ROW 124 + nDiff
         COL 70
         WIDTH 20
         WIDTH 60
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         MAXLENGTH 1
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         DATATYPE NUMERIC
         VALUE 0
      END TEXTBOX

      DEFINE LABEL SEEK_KEYWORD
         ROW 68 + nDiff
         COL 140
         WIDTH 90
         HEIGHT 24
         VALUE "no Kewword"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         ACTION DoSetFilterTo( 1 )
         TOOLTIP "click call Filter"
      END LABEL

      DEFINE LABEL SEEK_AUTHOR
         ROW 96 + nDiff
         COL 140
         WIDTH 90
         HEIGHT 24
         VALUE "no Author"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         ACTION DoSetFilterTo( 2 )
         TOOLTIP "click call Filter"
      END LABEL

      DEFINE LABEL SHOW_CODE
         ROW 124 + nDiff
         COL 140
         WIDTH 90
         HEIGHT 24
         VALUE ""
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         ACTION ShowMemoCODE( cMemoRow, cMemoCol, cMemoWidth, cMemoHeight, cFontSize )
         TOOLTIP "click to open Window"
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END LABEL

      DEFINE LABEL Label_TDATE
         ROW 68 + nDiff
         COL 240
         WIDTH 40
         HEIGHT 24
         VALUE "Date"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END LABEL

      DEFINE TEXTBOX Text_TDATE
         ROW 68 + nDiff
         COL 280
         WIDTH 80
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         MAXLENGTH 8
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         DATATYPE DATE
         VALUE CTOD( " . . " )
      END TEXTBOX

      DEFINE LABEL Label_TTIME
         ROW 96 + nDiff
         COL 240
         WIDTH 40
         HEIGHT 24
         VALUE "Time"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END LABEL

      DEFINE TEXTBOX Text_TTIME
         ROW 96 + nDiff
         COL 280
         WIDTH 80
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         MAXLENGTH 8
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         VALUE ""
      END TEXTBOX

      DEFINE LABEL Label_LINES
         ROW 124 + nDiff
         COL 240
         WIDTH 40
         HEIGHT 24
         VALUE "Lines"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END LABEL

      DEFINE TEXTBOX Text_CODLINES
         ROW 124 + nDiff
         COL 280
         WIDTH 80
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         MAXLENGTH 4
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         DATATYPE NUMERIC
         VALUE 0
      END TEXTBOX

      DEFINE LABEL Label_TOPIC
         ROW 186 + nDiff
         COL 10
         WIDTH 56
         HEIGHT 24
         VALUE "Topic"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END LABEL

      DEFINE TEXTBOX Text_TOPIC
         ROW 186 + nDiff
         COL 70
         WIDTH 290
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         MAXLENGTH 65
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         VALUE ""
      END TEXTBOX

      DEFINE LABEL Label_AUTHOR
         ROW 214 + nDiff
         COL 10
         WIDTH 56
         HEIGHT 24
         VALUE "Author"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END LABEL

      DEFINE TEXTBOX Text_AUTHOR
         ROW 214 + nDiff
         COL 70
         WIDTH 290
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         MAXLENGTH 40
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         VALUE ""
      END TEXTBOX

      DEFINE LABEL Label_1INFO
         ROW 242 + nDiff
         COL 10
         WIDTH 56
         HEIGHT 24
         VALUE "Info1"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END LABEL

      DEFINE TEXTBOX Text_1INFO
         ROW 242 + nDiff
         COL 70
         WIDTH 290
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         MAXLENGTH 15
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         VALUE ""
      END TEXTBOX

      DEFINE LABEL Label_2INFO
         ROW 270 + nDiff
         COL 10
         WIDTH 56
         HEIGHT 24
         VALUE "Info2"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END LABEL

      DEFINE TEXTBOX Text_2INFO
         ROW 270 + nDiff
         COL 70
         WIDTH 290
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         MAXLENGTH 15
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         VALUE ""
      END TEXTBOX

      DEFINE RICHEDITBOX RichEdit_Body
         ROW 300 + nDiff
         COL 10
         WIDTH 764
         HEIGHT 240 - nDiff
         VALUE ""
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         HSCROLL .T.
         BACKCOLOR nil
         ONLINK DoLink( ThisRichEditBox.GetClickLinkText )
      END RICHEDITBOX

   END WINDOW

   ON KEY ESCAPE OF FORUM ACTION nil
   ON KEY F1 OF FORUM ACTION HelpFile()
   ON KEY F5 OF FORUM ACTION ShowMemoCODE( cMemoRow, cMemoCol, cMemoWidth, cMemoHeight, cFontSize )
   ON KEY F7 OF FORUM ACTION DownloadRange()
   ON KEY F9 OF FORUM ACTION DoOpenCombo()
   ON KEY F11 OF FORUM ACTION TestLog()
   ON KEY CONTROL + U OF FORUM ACTION DoUserInfo()
   ON KEY CONTROL + F OF FORUM ACTION DoSetFilterTo()
   ON KEY CONTROL + L OF FORUM ACTION ListThreadNumber2Clip()

   CENTER WINDOW FORUM
   Activate Window FORUM

   IF lDebug = .T.
      ondummy( "Ende  : " + TIME() )
      SET ALTER TO
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure CreateSetup()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+                                   1 - static procedure checkdbf()
*+                                   1 - static procedure dochangeforum()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE CreateSetup( cDBF )

LOCAL oError, cText
LOCAL bOldError := ERRORBLOCK( { | e | BREAK( e ) } )
LOCAL aStruct   := { { "TOPICNO", "N", 6, 0 }, ;
                      { "FORUM", "N", 2, 0 }, ;
                      { "NOOFMSG", "N", 5, 0 }, ;
                      { "TDATE", "D", 8, 0 }, ;
                      { "TTIME", "C", 8, 0 }, ;
                      { "AUTHOR", "C", 40, 0 }, ;
                      { "LIKE", "N", 1, 0 }, ;
                      { "INFO1", "C", 15, 0 }, ;
                      { "INFO2", "C", 15, 0 }, ;
                      { "TOPIC", "C", 65, 0 }, ;
                      { "LINK", "C", 70, 0 }, ;
                      { "CODLINES", "N", 4, 0 }, ;
                      { "CODE", "M", 10, 0 }, ;
                      { "BODY", "M", 10, 0 } }

   BEGIN SEQUENCE

      DBCREATE( cDBF, aStruct, "DBFCDX" )

   RECOVER USING oError
      ERRORBLOCK( bOldError )
      IF oError:osCode = 32
         cText := "Error : " + oError:description + CRLF
         cText += "Operation : " + oError:operation + CRLF
         cText += CRLF
         cText += "FORUMHMG.exe seems to be still active" + CRLF
         cText += "start Taskmanager and terminate FORUMHMG.exe"

         MsgInfo( cText, "Error create DBF" )
         QUIT
      ENDIF
   END SEQUENCE
   ERRORBLOCK( bOldError )

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure CreateIndex()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+                                   1 - static procedure dochangeforum()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE CreateIndex( cDBF, cCDXname )

LOCAL cTAGname, cField

   // USE (cDBF) ALIAS "FORUM" VIA "DBFCDX"
   IF Net_Use( cDBF, .T., "FORUM" )

      cTAGname := "FORUM"
      cField := "FORUM"
      ORDCREATE( cCDXname, cTAGname, cField )
      CLOSE INDEX

      cTAGname := "AUTHOR"
      cField := "AUTHOR"
      ORDCREATE( cCDXname, cTAGname, cField )
      CLOSE INDEX

      cTAGname := "TOPIC"
      cField := "TOPIC"
      ORDCREATE( cCDXname, cTAGname, cField, .T., .T. )               // UNIQUE
      CLOSE INDEX

      cTAGname := "DUPECHECK"
      cField := "STRZERO(TOPICNO,5)+DTOS(TDATE)+TTIME"
      ORDCREATE( cCDXname, cTAGname, cField )
      CLOSE INDEX

      cTAGname := "MSGDATE"
      cField := "DTOS(TDATE)+TTIME"
      ORDCREATE( cCDXname, cTAGname, cField )
      CLOSE INDEX

      CLOSE
   ELSE
      MsgInfo( "Error open DBF", cDBF )
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure CreateForumDBF()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+                                   1 - static procedure checkforumdir()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE CreateForumDBF( cDBF )

LOCAL cHome   := hb_DirBase()
LOCAL aStruct := { { "FORUMNAME", "C", 40, 0 }, ;
                      { "LOCALPATH", "C", 80, 0 }, ;
                      { "FORUMURL", "C", 250, 0 }, ;
                      { "THREADSIGN", "C", 10, 0 } }

   DBCREATE( cDBF, aStruct, "DBFCDX" )

   SELECT 2
   // USE (cDBF) EXCLUSIVE VIA "DBFCDX"
   IF Net_Use( cDBF, .T. )

      IF FILE( "_FORUMDIR.DBF" )
         APPEND FROM _FORUMDIR.DBF
         REPLACE ALL FIELD->THREADSIGN WITH "?&t="
      ELSE

         APPEND BLANK
         REPLACE FIELD->FORUMNAME WITH "HMG Forum"
         REPLACE FIELD->FORUMURL WITH "https://www.hmgforum.com/viewtopic.php"
         REPLACE FIELD->LOCALPATH WITH cHome
         REPLACE FIELD->THREADSIGN WITH "?&t="

         APPEND BLANK
         REPLACE FIELD->FORUMNAME WITH "FiveWin"
         REPLACE FIELD->FORUMURL WITH "https://forums.fivetechsupport.com/viewtopic.php"
         REPLACE FIELD->LOCALPATH WITH cHome
         REPLACE FIELD->THREADSIGN WITH "?&t="

         APPEND BLANK
         REPLACE FIELD->FORUMNAME WITH "Xbase++"
         REPLACE FIELD->FORUMURL WITH "https://www.xbaseforum.de/viewtopic.php"
         REPLACE FIELD->LOCALPATH WITH cHome
         REPLACE FIELD->THREADSIGN WITH "?&t="

         APPEND BLANK
         REPLACE FIELD->FORUMNAME WITH "Express++"
         REPLACE FIELD->FORUMURL WITH "http://bb.donnay-software.com/donnay/phpbb3/viewtopic.php"
         REPLACE FIELD->LOCALPATH WITH cHome
         REPLACE FIELD->THREADSIGN WITH "?&t="

      ENDIF
      CLOSE
   ELSE
      MsgInfo( "Error open DBF", cDBF )
   ENDIF

   IF FILE( "_FORUMDIR.DBF" )
      FERASE( "_FORUMDIR.DBF" )
   ENDIF

   SELECT 1
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure CreateStripHTML()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE CreateStripHTML( cDBF )

LOCAL ii, iMax
LOCAL aStruct := { { "HTMLSIGN", "C", 80, 0 }, ;
                      { "CHANGETO", "C", 40, 0 } }

   aHTMLsign := GetHTMLsign()
   iMax := LEN( aHTMLsign )

   DBCREATE( cDBF, aStruct, "DBFCDX" )

   SELECT 3
   // USE (cDBF) EXCLUSIVE VIA "DBFCDX"
   IF Net_Use( cDBF, .T. )
      FOR ii := 1 TO iMax
         APPEND BLANK
         REPLACE FIELD->HTMLSIGN WITH aHTMLsign[ ii ] [ 1 ]
         REPLACE FIELD->CHANGETO WITH aHTMLsign[ ii ] [ 2 ]
      NEXT
      CLOSE
   ELSE
      MsgInfo( "Error open DBF", cDBF )
   ENDIF

   SELECT 1
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure CreateNotUser()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE CreateNotUser( cDBF )

LOCAL ii, iMax
LOCAL aStruct := { { "PHPFORUM", "C", 40, 0 }, ;
                      { "USERNAME", "C", 40, 0 } }

   DBCREATE( cDBF, aStruct, "DBFCDX" )

   SELECT 1

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure CreateColor()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE CreateColor( cDBF )

LOCAL ii, iMax
LOCAL aStruct := { { "BACKGROUND", "N", 9, 0 }, ;
                      { "FOREGRAUND", "N", 9, 0 } }

   DBCREATE( cDBF, aStruct, "DBFCDX" )

   // USE ( cDBF ) EXCLUSIVE VIA "DBFCDX"
   IF Net_Use( cDBF, .T. )
      APPEND BLANK
      REPLACE FIELD->BACKGROUND WITH SysColor2Num( COLOR_WINDOW )
      REPLACE FIELD->FOREGRAUND WITH SysColor2Num( COLOR_WINDOWTEXT )
      CLOSE
   ELSE
      MsgInfo( "Error open DBF", cDBF )
   ENDIF

   SELECT 1

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure CheckDBF()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+                                   1 - static procedure dochangeforum()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE CheckDBF( cWorkPath, cDBF )

LOCAL aStruct

   // USE (cWorkPath+cDBF) ALIAS "FORUM" VIA "DBFCDX"
   IF Net_Use( cWorkPath + cDBF, .F., "FORUM" )
      aStruct := DBSTRUCT()
      IF LEN( aStruct ) != ( 15 - 1 )
         CLOSE

         RENAME( cWorkPath + cDBF ) TO ( cWorkPath + "OLDDBFFF.DBF" )
         RENAME( cWorkPath + STRTRAN( UPPER( cDBF ), ".DBF", ".FPT" ) ) TO ( cWorkPath + "OLDDBFFF.FPT" )

         CreateSetup( cWorkPath + cDBF )

         // USE (cWorkPath+cDBF) ALIAS "FORUM" VIA "DBFCDX" EXCLUSIVE
         IF Net_Use( cWorkPath + cDBF, .T., "FORUM" )
            APPEND FROM ( cWorkPath + "OLDDBFFF.DBF" )
            CLOSE

            FERASE( cWorkPath + "OLDDBFFF.DBF" )
            FERASE( cWorkPath + "OLDDBFFF.FPT" )
         ELSE
            MsgInfo( "Error open DBF", cWorkPath + cDBF )
         ENDIF
      ENDIF
   ELSE
      MsgInfo( "Error open DBF", cWorkPath + cDBF )
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure CheckForumDir()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE CheckForumDir( cHome, cDBF )

LOCAL aStruct

   SELECT 2
   // USE (cHome+cDBF) ALIAS "FORUMDIR" VIA "DBFCDX"
   IF Net_Use( cHome + cDBF, .F., "FORUMDIR" )

      aStruct := DBSTRUCT()
      IF LEN( aStruct ) != ( 4 )
         CLOSE

         RENAME( cHome + cDBF ) TO ( cHome + "OLDDBFFD.DBF" )

         CreateForumDBF( cHome + cDBF )

         // USE (cHome+cDBF) ALIAS "FORUMDIR" VIA "DBFCDX" EXCLUSIVE
         IF Net_Use( cHome + cDBF, .T., "FORUMDIR" )
            APPEND FROM ( cHome + "OLDDBFFD.DBF" )
            CLOSE

            FERASE( cHome + "OLDDBFFD.DBF" )
         ELSE
            MsgInfo( "Error open DBF", cHome + cDBF )
         ENDIF
      ENDIF

      SELECT 2
      CLOSE
   ELSE
      MsgInfo( "Error open DBF", cHome + cDBF )
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure LoadConfig()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+                                   1 - static procedure dosaveini()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE LoadConfig( cRow, cCol, cWidth, cHeight, cMemoRow, cMemoCol, cMemoWidth, cMemoHeight, cFontSize, cPhPBB, cTLrow, cTLcol, cTLWidth, cTLHeight, cTranslateCP, cTransparent )

   IF !FILE( "Config.ini" )
      Begin ini FILE( "Config.ini" )
         Set Section "MAINWINDOW" ENTRY "Row" TO cRow
         Set Section "MAINWINDOW" ENTRY "Col" TO cCol
         Set Section "MAINWINDOW" ENTRY "Width" TO cWidth
         Set Section "MAINWINDOW" ENTRY "Height" TO cHeight
         Set Section "MAINWINDOW" ENTRY "Forum" TO cPhPBB

         Set Section "CODEWINDOW" ENTRY "MemoRow" TO cMemoRow
         Set Section "CODEWINDOW" ENTRY "MemoCol" TO cMemoCol
         Set Section "CODEWINDOW" ENTRY "MemoWidth" TO cMemoWidth
         Set Section "CODEWINDOW" ENTRY "MemoHeight" TO cMemoHeight
         Set Section "CODEWINDOW" ENTRY "FontSize" TO cFontSize

         Set Section "TRANSLATEWINDOW" ENTRY "TranslateRow" TO cTLrow
         Set Section "TRANSLATEWINDOW" ENTRY "TranslateCol" TO cTLcol
         Set Section "TRANSLATEWINDOW" ENTRY "TranslateWidth" TO cTLWidth
         Set Section "TRANSLATEWINDOW" ENTRY "TranslateHeight" TO cTLHeight
         Set Section "TRANSLATEWINDOW" ENTRY "TranslateCP" TO cTranslateCP

         Set Section "TRANSPARENCY" ENTRY "Transparency" TO cTransparent
      END ini
   ELSE
      Begin ini FILE( "Config.ini" )
         GET cRow Section "MAINWINDOW" ENTRY "Row"
         GET cCol Section "MAINWINDOW" ENTRY "Col"
         GET cWidth Section "MAINWINDOW" ENTRY "Width"
         GET cHeight Section "MAINWINDOW" ENTRY "Height"
         GET cPhPBB Section "MAINWINDOW" ENTRY "Forum"

         GET cMemoRow Section "CODEWINDOW" ENTRY "MemoRow"
         GET cMemoCol Section "CODEWINDOW" ENTRY "MemoCol"
         GET cMemoWidth Section "CODEWINDOW" ENTRY "MemoWidth"
         GET cMemoHeight Section "CODEWINDOW" ENTRY "MemoHeight"
         GET cFontSize Section "CODEWINDOW" ENTRY "FontSize"

         GET cTLrow Section "TRANSLATEWINDOW" ENTRY "TranslateRow"
         GET cTLcol Section "TRANSLATEWINDOW" ENTRY "TranslateCol"
         GET cTLWidth Section "TRANSLATEWINDOW" ENTRY "TranslateWidth"
         GET cTLHeight Section "TRANSLATEWINDOW" ENTRY "TranslateHeight"
         GET cTranslateCP Section "TRANSLATEWINDOW" ENTRY "TranslateCP"

         GET cTransparent Section "TRANSPARENCY" ENTRY "Transparency"

      END Ini
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoInit()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoInit( cForm, cRow, cCol, cWidth, cHeight, cPhPBB, cDBF, cCDX )

   FillComboForum( cPhPBB, cDBF, cCDX )

   GetLayout( cForm )

   ChangeFilter()
   // GO TOP
   GO BOTTOM
   Forum_Store()

   // new Size -> resize Layout
   SetProperty( cForm, "WIDTH", VAL( cWidth ) )
   SetProperty( cForm, "HEIGHT", VAL( cHeight ) )
   LayoutAdjust( cForm, 800, 600 )

   IF EMPTY( VAL( cRow ) ) .AND. EMPTY( VAL( cCol ) )
      CENTER WINDOW FORUM
   ELSE
      SetProperty( cForm, "ROW", VAL( cRow ) )
      SetProperty( cForm, "COL", VAL( cCol ) )
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure BeforeRelease()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE BeforeRelease()

   CLOSE ALL
   RELEASE ALL
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure FillComboForum()
*+
*+    Called from ( forumhmg.prg )   1 - static procedure doinit()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE FillComboForum( cPhPBB, cDBF, cCDX )

LOCAL nPosi := 1

   FORUM.Combo_PhpBB.DeleteAllItems()

   SELECT 2
   // USE "FORUMDIR.DBF" VIA "DBFCDX"
   IF Net_Use( "FORUMDIR.DBF", .F. )
      DO WHILE !EOF()
         IF !DELETED()
            FORUM.Combo_PhpBB.AddItem( FORUMDIR->FORUMNAME )
            AADD( aWorkPhpbb, FORUMDIR->FORUMNAME )
            IF LOWER( FORUMDIR->FORUMNAME ) = LOWER( cPhPBB )
               nPosi := RECNO()
            ENDIF
         ENDIF
         SKIP
      ENDDO
      CLOSE

      FORUM.Combo_PhpBB.Value := nPosi
      cWorkPhpbb := aWorkPhpbb[ nPosi ]

      DoChangeForum( cDBF, cCDX )

   ELSE
      MsgInfo( "Error open DBF", "FORUMDIR.DBF" )
   ENDIF

   SELECT 1
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure Forum_Store()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+                                   1 - static procedure doinit()
*+                                   1 - procedure dobrowserefresh()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE Forum_Store()

   FORUM.Text_TREADNO.Value := FORUM->TOPICNO
   FORUM.Text_NOOFMSG.Value := FORUM->NOOFMSG
   FORUM.Text_TDATE.Value := FORUM->TDATE
   FORUM.Text_TTIME.Value := FORUM->TTIME
   FORUM.Text_AUTHOR.Value := FORUM->AUTHOR
   FORUM.Text_LIKE.Value := FORUM->LIKE
   FORUM.Text_1INFO.Value := FORUM->INFO1
   FORUM.Text_2INFO.Value := FORUM->INFO2
   FORUM.Text_CODLINES.Value := FORUM->CODLINES
   FORUM.Text_TOPIC.Value := FORUM->TOPIC
   FORUM.Text_LINK.Value := FORUM->LINK
   FORUM.RichEdit_Body.Value := TRIM( FORUM->BODY )

   IF IsControlDefined( "SHOW_CODE", "FORUM" )
      IF !EMPTY( TRIM( FORUM->CODE ) )
         FORUM.SHOW_CODE.VALUE := "have Code"
         FORUM.SHOW_CODE.BACKCOLOR := GREEN
         FORUM.SHOW_CODE.FONTCOLOR := BLACK
      ELSE
         FORUM.SHOW_CODE.VALUE := "no Code"
         FORUM.SHOW_CODE.BACKCOLOR := BGfont
         FORUM.SHOW_CODE.FONTCOLOR := FGfont
      ENDIF
   ENDIF

   IF IsControlDefined( "RichEdit_Code", "SHOWMEMO" )
      SetProperty( "SHOWMEMO", "RichEdit_Code", "Value", TRIM( FORUM->CODE ) )
      IF !EMPTY( TRIM( FORUM->CODE ) )
         SetTransparency( "SHOWMEMO", 100 )
      ELSE
         SetTransparency( "SHOWMEMO", nTransparent )
      ENDIF
   ENDIF

   IF !EMPTY( cWorkKeyWord )
      FindReplRTFProc( cWorkKeyWord )
   ENDIF

   IF IsControlDefined( "RichEdit_Translate", "TranslateMemo" )
      IF lTranslate = .T.
         TranslateByGoogle( TRIM( FORUM->BODY ), cTranslateCP )
      ENDIF
      DO EVENTS
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure Forum_Replace()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE Forum_Replace()                                      // unused

LOCAL nRecord := RECNO()

   IF Net_Lock( nRecord )
      REPLACE FORUM->TOPICNO WITH FORUM.Text_TREADNO.Value
      REPLACE FORUM->NOOFMSG WITH FORUM.Text_NOOFMSG.Value
      REPLACE FORUM->TDATE WITH FORUM.Text_TDATE.Value
      REPLACE FORUM->TTIME WITH FORUM.Text_TTIME.Value
      REPLACE FORUM->AUTHOR WITH FORUM.Text_AUTHOR.Value
      REPLACE FORUM->LIKE WITH FORUM.Text_LIKE.Value
      REPLACE FORUM->INFO1 WITH FORUM.Text_1INFO.Value
      REPLACE FORUM->INFO2 WITH FORUM.Text_2INFO.Value
      REPLACE FORUM->TOPIC WITH FORUM.Text_TOPIC.Value
      REPLACE FORUM->LINK WITH FORUM.Text_LINK.Value
      REPLACE FORUM->BODY WITH TRIM( FORUM.RichEdit_Body.Value )

      DBRUNLOCK( nRecord )
      SKIP( 0 )
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure FindReplRTFProc()
*+
*+    Called from ( forumhmg.prg )   1 - static procedure forum_store()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE FindReplRTFProc( cFind )

LOCAL aPosRange       := { 0, 0 }
LOCAL lDown           := .T.
LOCAL lMatchCase      := .T.
LOCAL lWholeWord      := .F.
LOCAL lSelectFindText := .T.

   aPosRange := FORUM.RichEdit_Body.FindText( cFind, lDown, lMatchCase, lWholeWord, lSelectFindText )

   IF aPosRange[ 1 ] == - 1
      // MsgInfo( "Can't find the text:" + HB_OSNEWLINE() + cFind )
   ELSE
      FORUM.RichEdit_Body.SelectRange := { aPosRange[ 1 ], aPosRange[ 1 ] + LEN( cFind ) }
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoCleanBody()
*+
*+    Called from ( forumhmg.prg )   2 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoCleanBody( cDBF, cCDX )

LOCAL ii, cBody, cCODE, cTopic, cLine, nRecord, nPosi, nStart := 1
LOCAL aPosi       := {}
LOCAL nCount      := 0
LOCAL nMsgNo      := 0
LOCAL nLastThread := 0
LOCAL nMax
LOCAL nEvery
LOCAL nThreadNo

   DoFillHTMLsign()

   SELECT 1
   nRecord := RECNO()
   CLOSE

   SetNewCursor( "WAIT" )
   DO EVENTS

   // USE (cWorkPath+cDBF) ALIAS "FORUM" VIA "DBFCDX" EXCLUSIVE
   IF Net_Use( cWorkPath + cDBF, .T., "FORUM" )

      SET INDEX TO ( cWorkPath + cCDX )
      ORDSETFOCUS( "DUPECHECK" )

      nMax := LASTREC()
      nEvery := INT( nMax / 100 )
      SetProperty( "FORUM", "ProgressBar_1", "Value", 0 )
      SetProperty( "FORUM", "ProgressBar_1", "VISIBLE", .T. )

      SayBarText(, "ICOCLEAN" )
      GO TOP
      DO WHILE !EOF()
         IF !EMPTY( FORUM->BODY )
            cBody := FORUM->BODY
            nThreadNo := FORUM->TOPICNO

            IF nLastThread <> nThreadNo
               nLastThread := nThreadNo
               nMsgNo := 1

               // SayBarText( STRZERO( FORUM->TOPICNO, 5 ) + " " + FORUM->AUTHOR + " " + FORUM->TOPIC )
            ELSE
               nMsgNo ++
            ENDIF

            // 13.09.2022
            EofBody( @cBody )

            FOR ii := 1 TO LEN( aHTMLsign )
               cBody := STRTRAN( cBody, TRIM( aHTMLsign[ ii ] [ 1 ] ), TRIM( aHTMLsign[ ii ] [ 2 ] ) )
            NEXT

            REPLACE FORUM->BODY WITH TRIM( cBody )
            REPLACE FORUM->NOOFMSG WITH nMsgNo

            IF '<dl class="file">' $ cBody
               aPosi := MarkerPos( '<dl class="file">', cBody )
               FOR ii := 1 TO LEN( aPosi )
                  nStart := aPosi[ ii ]
                  nPosi := HB_AT( '<dt class="attach-image">', cBody, nStart )
                  IF nPosi > 0
                     REPLACE FORUM->INFO1 WITH "Have Image"
                     LOOP
                  ENDIF

                  nPosi := HB_AT( '<dt><span class="', cBody, nStart )
                  IF nPosi > 0
                     REPLACE FORUM->INFO2 WITH "Have Attachment"
                  ENDIF
               NEXT
            ENDIF
         ENDIF

         IF !EMPTY( TRIM( FORUM->CODE ) )
            cCODE := TRIM( FORUM->CODE )

            cLine := ALLTRIM( MEMOLINE( cCode, 90, 1 ) )
            IF "<div class=" $ cLine
               cCODE := ALLTRIM( STRTRAN( cCODE, cLine, "" ) )
            ENDIF

            // change HTML in CODE
            StripCodeTag( @cCode )

            cCODE := STRTRAN( cCODE, CHR( 0 ), CRLF )

            cCODE := ALLTRIM( cCODE )
            REPLACE FORUM->CODE WITH TRIM( cCODE )

         ENDIF

         nCount ++
         IF ( ( nCount ) % ( nEvery ) ) == 0
            DO EVENTS
            SetProperty( "FORUM", "ProgressBar_1", "Value", CalcPos( nCount, nMax ) )
         ENDIF

         SKIP
      ENDDO
      SetProperty( "FORUM", "ProgressBar_1", "VISIBLE", .F. )
      SayBarText(, "ICONONE" )
      CLOSE

      // USE (cWorkPath+cDBF) ALIAS "FORUM" VIA "DBFCDX"
      IF Net_Use( cWorkPath + cDBF, .F., "FORUM" )

         SET INDEX TO ( cWorkPath + cCDX )
         ORDSETFOCUS( "MSGDATE" )
         GO BOTTOM

         DoBrowseRefresh(, nRecord )
      ELSE
         MsgInfo( "Error open DBF", cWorkPath + cDBF )
      ENDIF

   ELSE
      MsgInfo( "Error open DBF", cWorkPath + cDBF )
   ENDIF

   SetNewCursor()
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoChangeForum()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+                                   1 - static procedure fillcomboforum()
*+                                   1 - static procedure donextforum()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoChangeForum( cDBF, cCDX )

LOCAL nPosi := FORUM.Combo_PhpBB.VALUE

   SayBarText(, "ICONONE" )

   cWorkPhpbb := aWorkPhpbb[ nPosi ]

   SELECT 1
   CLOSE

   SELECT 2
   // USE "FORUMDIR.DBF" VIA "DBFCDX"
   IF Net_Use( "FORUMDIR.DBF", .F. )
      GOTO( nPosi )
      cWorkPath := TRIM( FORUMDIR->LOCALPATH )
      cWorkURL := TRIM( FORUMDIR->FORUMURL )
      cWorkSign := TRIM( FORUMDIR->THREADSIGN )
      CLOSE
   ELSE
      MsgInfo( "Error open DBF", "FORUMDIR.DBF" )
   ENDIF

   SELECT 1
   IF !FILE( cWorkPath + cDBF )
      CreateSetup( cWorkPath + cDBF )
   ENDIF

   CheckDBF( cWorkPath, cDBF )

   IF !FILE( cWorkPath + cCDX )
      CreateIndex( cWorkPath + cDBF, cWorkPath + cCDX )
   ENDIF

   // USE (cWorkPath+cDBF) ALIAS "FORUM" VIA "DBFCDX"
   IF Net_Use( cWorkPath + cDBF, .F., "FORUM" )

      SET INDEX TO ( cWorkPath + cCDX )
      ORDSETFOCUS( "MSGDATE" )

      FORUM.RadioGroup_1.value := 1
      ChangeFilter()
      GO BOTTOM

      DO EVENTS

      DoBrowseRefresh()
      DO EVENTS

      DoMethod( "FORUM", "Browse_Main", "SetFocus" )
      DO EVENTS

   ELSE
      MsgInfo( "Error open DBF", cWorkPath + cDBF )
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure HelpFile()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE HelpFile()

LOCAL cText := ""

   cText += "F1 This Help" + CRLF
   cText += "F5 Window for CODE" + CRLF
   cText += "F7 Download new Message" + CRLF
   cText += "F9 Focus Combobox and open" + CRLF
   cText += "" + CRLF
   cText += "CTRL+F Set FILTER" + CRLF

   msgInfo( cText )
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoUserInfo()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoUserInfo()

LOCAL nRecord, cText
LOCAL nCount  := 0
LOCAL nCode   := 0
LOCAL nLines  := 0
LOCAL nSum    := 0
LOCAL nImage  := 0
LOCAL nAttach := 0

   IF USED()
      IF !EMPTY( cWorkAuthor )
         SetNewCursor( "WAIT" )
         DO EVENTS

         GO TOP
         nCount := 0
         DO WHILE !EOF()
            nCount ++
            IF !EMPTY( TRIM( FORUM->CODE ) )
               nCode ++
               nRecord := RECNO()
               IF Net_Lock( nRecord )
                  nLines := MLCOUNT( FORUM->CODE, 80 )
                  REPLACE FORUM->CODLINES WITH nLines
                  DBRUNLOCK( nRecord )
                  nSum += nLines
               ENDIF
            ENDIF
            IF FORUM->INFO1 = "Have Image"
               nImage ++
            ENDIF
            IF FORUM->INFO2 = "Have Attachment"
               nAttach ++
            ENDIF

            SKIP
         ENDDO
         SetNewCursor()

         DoBrowseRefresh()

         cText := cWorkAuthor + CRLF + CRLF
         cText += "Post Message : " + LTRIM( STR( nCount ) ) + CRLF
         cText += "CODE Sample  : " + LTRIM( STR( nCode ) ) + CRLF
         cText += "CODE Lines   : " + LTRIM( STR( nSum ) ) + CRLF
         cText += "Attachment   : " + LTRIM( STR( nAttach ) ) + CRLF
         cText += "Image        : " + LTRIM( STR( nImage ) ) + CRLF

         MsgInfo( cText )
      ELSE
         MsgInfo( "must set FILTER on Author", "Error Author" )
      ENDIF
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure HeadSort()
*+
*+    Called from ( forumhmg.prg )   4 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE HeadSort( nSort )

LOCAL nRecord := RECNO()

   DO CASE
      CASE nSort = 1
         ORDSETFOCUS( "AUTHOR" )
      CASE nSort = 2
         ORDSETFOCUS( "TOPIC" )
      CASE nSort = 3
         ORDSETFOCUS( "MSGDATE" )
      CASE nSort = 4
         ORDSETFOCUS( "DUPECHECK" )
   ENDCASE

   DoBrowseRefresh(, nRecord )

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoOpenCombo()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoOpenCombo()

   FORUM.Combo_PhpBB.SetFocus
   // Keyboard(VK_F4)
   Keybd_Event( VK_F4, .F. )                                          // KeyDown
   Keybd_Event( VK_F4, .T. )                                          // KeyUp

   DO EVENTS                                                          // need for Keybd_Event()

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoNextForum()
*+
*+    Called from ( forumhmg.prg )   2 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoNextForum( cDBF, cCDX )

LOCAL nPosi := FORUM.Combo_PhpBB.VALUE
LOCAL nMax  := FORUM.Combo_PhpBB.ItemCount

   IF nPosi + 1 <= nMax
      FORUM.Combo_PhpBB.VALUE := nPosi + 1
   ELSE
      FORUM.Combo_PhpBB.VALUE := 1
   ENDIF

   DoChangeForum( cDBF, cCDX )

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoSaveINI()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoSaveINI( cMemoRow, cMemoCol, cMemoWidth, cMemoHeight, cFontSize, cPhPBB, cTLrow, cTLcol, cTLWidth, cTLHeight, cTranslateCP, cTransparent )

LOCAL cRow, cCol, cWidth, cHeight

   FERASE( "CONFIG.INI" )

   cRow := LTRIM( STR( GetProperty( "FORUM", "ROW" ) ) )
   cCol := LTRIM( STR( GetProperty( "FORUM", "COL" ) ) )
   cWidth := LTRIM( STR( GetProperty( "FORUM", "WIDTH" ) ) )
   cHeight := LTRIM( STR( GetProperty( "FORUM", "HEIGHT" ) ) )
   cTransparent := LTRIM( STR( nTransparent ) )

   IF isWindowDefined( "SHOWMEMO" )
      cMemoRow := LTRIM( STR( GetProperty( "SHOWMEMO", "ROW" ) ) )
      cMemoCol := LTRIM( STR( GetProperty( "SHOWMEMO", "COL" ) ) )
      cMemoWidth := LTRIM( STR( GetProperty( "SHOWMEMO", "WIDTH" ) ) )
      cMemoHeight := LTRIM( STR( GetProperty( "SHOWMEMO", "HEIGHT" ) ) )
   ENDIF

   IF isWindowDefined( "TranslateMemo" )
      cTLrow := LTRIM( STR( GetProperty( "TranslateMemo", "ROW" ) ) )
      cTLcol := LTRIM( STR( GetProperty( "TranslateMemo", "COL" ) ) )
      cTLWidth := LTRIM( STR( GetProperty( "TranslateMemo", "WIDTH" ) ) )
      cTLHeight := LTRIM( STR( GetProperty( "TranslateMemo", "HEIGHT" ) ) )
   ENDIF

   LoadConfig( @cRow, @cCol, @cWidth, @cHeight, @cMemoRow, @cMemoCol, @cMemoWidth, @cMemoHeight, @cFontSize, @cPhPBB, @cTLrow, @cTLcol, @cTLWidth, @cTLHeight, @cTranslateCP, @cTransparent )

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure TestLog()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE TestLog()

   DoErrorLog( "GENERATE" )
   DoErrorLog( "LISTBOX" )
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure ListThreadNumber2Clip()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE ListThreadNumber2Clip()

LOCAL oldRec, cText := ""

   IF EMPTY( cWorkKeyWord )
      MsgInfo( "need FILTER" )
   ELSE
      oldRec := RECNO()
      GO TOP
      DO WHILE !EOF()
         cText += STRZERO( FIELD->TOPICNO, 5 ) + CRLF
         SKIP
      ENDDO

      System.Clipboard := cText
      GOTO( oldRec )
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure DoLink()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+                ( showmemo.prg )   1 - procedure showmemoform()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DoLink( cLink )

LOCAL cTitle := "Error"
   DO CASE
      CASE HMG_LOWER( HB_USUBSTR( cLink, 1, 7 ) ) == 'http://' .OR. ;
                         HMG_LOWER( HB_USUBSTR( cLink, 1, 8 ) ) == 'https://' .OR. ;
                         HMG_LOWER( HB_USUBSTR( cLink, 1, 6 ) ) == 'ftp://' .OR. ;
                         HMG_LOWER( HB_USUBSTR( cLink, 1, 4 ) ) == 'www.'
         SHELLEXECUTE( NIL, 'Open', cLink, NIL, NIL, SW_SHOWNORMAL )
      CASE '@' $ cLink .AND. !( '/' $ cLink )
         SHELLEXECUTE( NIL, 'Open', 'rundll32.exe', 'url.dll,FileProtocolHandler mailto:' + cLink, NIL, SW_SHOWNORMAL )
      OTHERWISE
         MSGEXCLAMATION( 'Cannot launch ' + cLink + '', cTitle )
   ENDCASE
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure ChangeFilter()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+                                   1 - static procedure doinit()
*+                                   1 - static procedure dochangeforum()
*+                ( setfilter.prg )   1 - static procedure dosetnewfilter()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE ChangeFilter()

LOCAL nItem := FORUM.RadioGroup_1.value

   // for FILTER it must be PRIVATE / PUBLIC

   DO CASE
      CASE EMPTY( cWorkKeyWord ) .AND. EMPTY( cWorkAuthor )
         DO CASE
            CASE nItem = 1
               SET FILTER TO
            CASE nItem = 2
               SET FILTER TO !EMPTY( FORUM->CODE ) .OR. !EMPTY( FORUM->INFO2 )
            CASE nItem = 3
               SET FILTER TO !EMPTY( FORUM->CODE )
            CASE nItem = 4
               SET FILTER TO !EMPTY( FORUM->INFO2 )
         ENDCASE

      CASE !EMPTY( cWorkKeyWord ) .AND. !EMPTY( cWorkAuthor )
         DO CASE
            CASE nItem = 1

               IF lNotUser = .T.
                  SET FILTER TO ( TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->CODE ) ) .OR. TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->BODY ) ) ) ;
                                  .AND. .NOT. TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor )
               ELSE
                  SET FILTER TO ( TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->CODE ) ) .OR. TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->BODY ) ) ) ;
                                  .AND. TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor )
               ENDIF

            CASE nItem = 2
               IF lNotUser = .T.
                  SET FILTER TO !EMPTY( FORUM->CODE ) .OR. !EMPTY( FORUM->INFO2 ) ;
                                        .AND. .NOT. TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor ) .AND. ( TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->CODE ) ) .OR. TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->BODY ) ) )
               ELSE
                  SET FILTER TO !EMPTY( FORUM->CODE ) .OR. !EMPTY( FORUM->INFO2 ) ;
                                        .AND. LOWER( FORUM->AUTHOR ) $ LOWER( cWorkAuthor ) .AND. ( TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->CODE ) ) .OR. TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->BODY ) ) )
               ENDIF
            CASE nItem = 3
               IF lNotUser = .T.
                  SET FILTER TO !EMPTY( FORUM->CODE ) ;
                                        .AND. .NOT. TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor ) .AND. ( TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->CODE ) ) .OR. TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->BODY ) ) )
               ELSE
                  SET FILTER TO !EMPTY( FORUM->CODE ) ;
                                        .AND. LOWER( FORUM->AUTHOR ) $ LOWER( cWorkAuthor ) .AND. ( TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->CODE ) ) .OR. TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->BODY ) ) )
               ENDIF

            CASE nItem = 4
               IF lNotUser = .T.
                  SET FILTER TO !EMPTY( FORUM->INFO2 ) ;
                                        .AND. .NOT. TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor ) .AND. ( TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->CODE ) ) .OR. TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->BODY ) ) )
               ELSE
                  SET FILTER TO !EMPTY( FORUM->INFO2 ) ;
                                        .AND. TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor ) .AND. ( TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->CODE ) ) .OR. TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->BODY ) ) )
               ENDIF

         ENDCASE

      CASE !EMPTY( cWorkAuthor )
         DO CASE
            CASE nItem = 1
               IF lNotUser = .T.
                  SET FILTER TO .NOT. TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor )
               ELSE
                  SET FILTER TO TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor )
               ENDIF
            CASE nItem = 2
               IF lNotUser = .T.
                  SET FILTER TO !EMPTY( FORUM->CODE ) .OR. !EMPTY( FORUM->INFO2 ) .AND. .NOT. TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor )
               ELSE
                  SET FILTER TO !EMPTY( FORUM->CODE ) .OR. !EMPTY( FORUM->INFO2 ) .AND. TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor )
               ENDIF
            CASE nItem = 3
               IF lNotUser = .T.
                  SET FILTER TO !EMPTY( FORUM->CODE ) .AND. .NOT. TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor )
               ELSE
                  SET FILTER TO !EMPTY( FORUM->CODE ) .AND. TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor )
               ENDIF
            CASE nItem = 4
               IF lNotUser = .T.
                  SET FILTER TO !EMPTY( FORUM->INFO2 ) .AND. .NOT. TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor )
               ELSE
                  SET FILTER TO !EMPTY( FORUM->INFO2 ) .AND. TRIM( LOWER( FORUM->AUTHOR ) ) $ LOWER( cWorkAuthor )
               ENDIF
         ENDCASE

      CASE !EMPTY( cWorkKeyWord )
         DO CASE
            CASE nItem = 1
               SET FILTER TO ( TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->CODE ) ) .OR. TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->BODY ) ) )
            CASE nItem = 2
               SET FILTER TO !EMPTY( FORUM->CODE ) .OR. !EMPTY( FORUM->INFO2 ) ;
                                     .AND. ( TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->CODE ) ) .OR. TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->BODY ) ) )
            CASE nItem = 3
               SET FILTER TO !EMPTY( FORUM->CODE ) .AND. ( TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->CODE ) ) .OR. TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->BODY ) ) )
            CASE nItem = 4
               SET FILTER TO !EMPTY( FORUM->INFO2 ) ;
                                     .AND. ( TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->CODE ) ) .OR. TRIM( LOWER( cWorkKeyWord ) ) $ TRIM( LOWER( FORUM->BODY ) ) )
         ENDCASE
   ENDCASE

   DoBrowseRefresh()

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure DoBrowseSetFocus()
*+
*+    Called from ( forumhmg.prg )   3 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DoBrowseSetFocus( lFocus )

LOCAL hGrid   := GetControlHandle( "Browse_Main", "FORUM" )
LOCAL nRecord := FORUM.Browse_Main.Value

   DEFAULT lFocus TO .T.

   IF lFocus = .T.
      DoMethod( "FORUM", "Browse_Main", "SetFocus" )
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure DoBrowseRefresh()
*+
*+    Called from ( dlrange.prg )   1 - static procedure dodownloadnow()
*+                ( forumhmg.prg )   1 - static procedure docleanbody()
*+                                   1 - static procedure dochangeforum()
*+                                   1 - static procedure douserinfo()
*+                                   1 - static procedure headsort()
*+                                   1 - procedure changefilter()
*+                                   1 - procedure dorenewmsg()
*+                ( listlog.prg )   1 - static procedure dogototread()
*+                                   1 - static procedure rereadthread()
*+                ( setfilter.prg )   2 - static procedure dosetnewfilter()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DoBrowseRefresh( lWasCreate, nLastRec )

LOCAL ii, hGrid := GetControlHandle( "Browse_Main", "FORUM" )
LOCAL nRecord

   DEFAULT lWasCreate TO .F.

   IF !EMPTY( nLastRec )
      GOTO( nLastRec )
   ELSE
      // GO TOP
      GO BOTTOM
   ENDIF
   nRecord := RECNO()
   Forum_Store()
   FORUM.Browse_Main.Value := nRecord
   FORUM.Browse_Main.Refresh
   FORUM.Browse_Main.SetFocus

   IF lWasCreate = .T.
      FOR ii := 1 TO 4
         LISTVIEW_SETCOLUMNWIDTH( hGrid, ii - 1, - 1 )
      NEXT
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure RTF2Clip()
*+
*+    Called from ( forumhmg.prg )   2 - procedure main()
*+                ( showmemo.prg )   1 - procedure showmemoform()
*+                ( translat.prg )   1 - procedure translatememoform()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE RTF2Clip( cOption )

LOCAL cText := ""
LOCAL nLen  := 0

   DO CASE
      CASE EMPTY( cOption )

      CASE cOption = "BODY"
         cText := GetProperty( "FORUM", "RichEdit_Body", "GetSelectText" )

      CASE cOption = "CODE"
         cText := GetProperty( "SHOWMEMO", "RichEdit_Code", "GetSelectText" )
         IF EMPTY( TRIM( cText ) )
            nLen := GetProperty( "SHOWMEMO", "RichEdit_Code", "GetTextLength" )
            SetProperty( "SHOWMEMO", "RichEdit_Code", "SelectRange", { 1, nLen } )
            cText := GetProperty( "SHOWMEMO", "RichEdit_Code", "GetSelectText" )
         ENDIF
      CASE cOption = "TRANSLATE"
         nLen := GetProperty( "TranslateMemo", "RichEdit_Translate", "GetTextLength" )
         SetProperty( "TranslateMemo", "RichEdit_Translate", "SelectRange", { 1, nLen } )
         cText := GetProperty( "TranslateMemo", "RichEdit_Translate", "GetSelectText" )

   ENDCASE

   IF !EMPTY( cText )
      System.Clipboard := cText
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure ShowMemoCODE()
*+
*+    Called from ( forumhmg.prg )   2 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE ShowMemoCODE( cMemoRow, cMemoCol, cMemoWidth, cMemoHeight, cFontSize )

   // LOCAL oThread
   //
   //    oThread := hb_threadStart( HB_THREAD_INHERIT_PUBLIC, @SHOWMEMOFORM(), cMemoRow, cMemoCol, cMemoWidth, cMemoHeight, cFontSize )
   //    AttachThreadInput( nMainThreadID, HMG_ThreadHBtoWinID( oThread ), .T. )

   SHOWMEMOFORM( cMemoRow, cMemoCol, cMemoWidth, cMemoHeight, cFontSize )

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure SetTransparency()
*+
*+    Called from ( forumhmg.prg )   2 - static procedure forum_store()
*+                ( showmemo.prg )  10 - procedure showmemoform()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE SetTransparency( cForm, nIn )

LOCAL nValue := 255 / 100
   SetProperty( cForm, "AlphaBlendTransparent", INT( nValue * nIn ) )
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure DoReNewMsg()
*+
*+    Called from ( dlallcod.prg )   1 - static procedure newfwcode()
*+                ( forumhmg.prg )   2 - procedure main()
*+                ( listlog.prg )   1 - static procedure rereadthread()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DoReNewMsg( lShow )

LOCAL cFile, nThreadNo, dDATE, cTime, cSeek
LOCAL cURL
LOCAL cHome     := hb_DirBase()
LOCAL nRecord   := RECNO()
LOCAL nAllItems := 0                                                  // "posts" of Thread
LOCAL nStartPG  := 1                                                  // Startpage No.
LOCAL nMsgNo    := 0
LOCAL nLock

   DEFAULT lShow TO .T.

   IF .NOT. IsInternet()
      SayBarText(, "ICOSTOP" )
      RETURN
   ENDIF

   SET DATE ANSI
   SET CENTURY ON

   nThreadNo := FORUM->TOPICNO
   dDATE := FORUM->TDATE
   cTime := FORUM->TTIME

   // cFile := GetUniqueFileName( cHome )
   cFile := GetThreadFileName( cWorkPath, nThreadNo )

   FORUM.RadioGroup_1.value := 1
   SET FILTER TO
   ORDSETFOCUS( "DUPECHECK" )

   cURL := cWorkURL + cWorkSign + LTRIM( STR( nThreadNo ) )

   IF lShow = .T.
      SayBarText( "reload Thread " + LTRIM( STR( nThreadNo ) ), "ICORELOAD" )
   ENDIF
   SetNewCursor( "WAIT" )
   DO EVENTS

   DO WHILE .T.
      nAllItems := 0
      nMsgNo ++

      DownloadFromWWW( cURL, cFile, nThreadNo )

      IF FILE( cFile )
         nAllItems := StripHTMLCode( cFile, nThreadNo, .T. )
      ELSE
         EXIT
      ENDIF

      nStartPG ++
      IF nStartPG * 10 < nAllItems
         cURL := cWorkURL + cWorkSign + LTRIM( STR( nThreadNo ) ) + "&start=" + LTRIM( STR( nStartPG * 10 ) )
         OnDummy( TIME(), "next Page", nStartPG, nAllItems, cURL )
      ELSE
         EXIT
      ENDIF

      nLock := RECNO()
      IF Net_Lock( nLock )
         REPLACE FORUM->NOOFMSG WITH nMsgNo
         DBRUNLOCK( nLock )
         SKIP( 0 )
      ENDIF

      DO EVENTS
   ENDDO
   IF lShow = .T.
      SayBarText(, "ICONONE" )
   ENDIF
   SetNewCursor()

   IF lDebug = .F.
      FERASE( cFile )
   ENDIF

   SET DATE GERMAN

   ORDSETFOCUS( "MSGDATE" )
   IF lShow = .T.
      DoBrowseRefresh(, nRecord )
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure SetNewCursor()
*+
*+    Called from ( dlallcod.prg )   2 - static procedure newfwcode()
*+                ( dlrange.prg )   2 - static procedure startdownload()
*+                ( forumhmg.prg )   2 - static procedure docleanbody()
*+                                   2 - static procedure douserinfo()
*+                                   2 - procedure dorenewmsg()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE SetNewCursor( cCursor )

LOCAL Hwnd, xCursor, hControl, i, k
LOCAL ParentForm, ControlCount, ControlName

   Hwnd := GetFormhandle( "FORUM" )

   DO CASE
      CASE EMPTY( cCursor )
         xCursor := IDC_ARROW
      CASE cCursor = "WAIT"
         xCursor := IDC_WAIT
      CASE cCursor = "ARROW"
         xCursor := IDC_ARROW
   ENDCASE

   i := ASCAN( _HMG_SYSDATA[ 67 ], hWnd )
   IF i > 0
      ParentForm := _HMG_SYSDATA[ 66 ] [ i ]
      ControlCount := LEN( _HMG_SYSDATA[ 3 ] )
      FOR k := 1 TO ControlCount
         ControlName := UPPER( _HMG_SYSDATA[ 2, k ] )
         IF IsControlDefined( ControlName, ParentForm )
            hControl := GetControlHandle( ControlName, ParentForm )
            SetWindowCursor( hControl, xCursor )
         ENDIF
      NEXT
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Function SHELLOPENFILE()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION SHELLOPENFILE( cCmd )

LOCAL lSuccess
LOCAL Retvar   := .F.

   IF EMPTY( cCmd )
      RETURN .F.
   ENDIF

   lSuccess := DllCall( "SHELL32.DLL", DLL_STDCALL, ;
                        "ShellExecuteW", 0, "open", cCmd, ;
                        NIL, CURDIR(), SW_NORMAL )                    // SW_MAXIMIZE

   DO CASE

      CASE lSuccess > 32                                              // Aufruf erfolgreich
         Retvar := .T.

      CASE lSuccess = SE_ERR_NOASSOC                                  // Keine verknpfte Anwendung

         // Falls ShowOpenWithDialog = True, wird der Dialog
         // "™ffnen mit" fr diese Datei angezeigt:
         // Shell "RunDLL32 shell32.dll,OpenAs_RunDLL " & Filename

         DllCall( "SHELL32.DLL", DLL_STDCALL, ;
                  "OpenAs_RunDLL", 0, NIL, cCmd, ;
                  NIL, CURDIR(), SW_NORMAL )                          // SW_MAXIMIZE

         // Die Auswahlm”glichkeit wird als Erfolg gewertet:
         Retvar := .T.
      OTHERWISE
         // ShellExecute war erfolglos.
         // Boolean-Standardwert False zurckgeben

         Retvar := .F.
   ENDCASE

RETURN Retvar

*+--------------------------------------------------------------------
*+
*+    Function CalcPos()
*+
*+    Called from ( dlallcod.prg )   1 - static procedure newfwcode()
*+                ( forumhmg.prg )   1 - static procedure docleanbody()
*+
*+--------------------------------------------------------------------
*+
FUNCTION CalcPos( nValue, iMax )

LOCAL nRet   := 0
LOCAL nEvery
LOCAL xScale

   IF iMax < 100
      nEvery := 100 / iMax
      nRet := nValue * nEvery
   ELSE
      nEvery := INT( iMax / 100 )
      xScale := iMax * nEvery                                         // Scale to 100%
      nRet := iMax / xScale * nValue
   ENDIF

RETURN ROUND( nRet, 0 )

*+--------------------------------------------------------------------
*+
*+    Function Net_Lock()
*+
*+    Called from ( color.prg )   1 - static procedure color_replace()
*+                ( dlforum.prg )   1 - static procedure doendmsg()
*+                ( editdbf.prg )   1 - static procedure forumdir_replace()
*+                                   1 - static procedure forumdir_delete()
*+                                   1 - static procedure htmlsign_replace()
*+                                   1 - static procedure htmlsign_delete()
*+                                   1 - static procedure notuser_replace()
*+                                   1 - static procedure notuser_delete()
*+                ( forumhmg.prg )   1 - static procedure forum_replace()
*+                                   1 - static procedure douserinfo()
*+                                   1 - procedure dorenewmsg()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Net_Lock( nRecord, cAlias )

LOCAL nWaitTine := 3
LOCAL lRet      := .F.

   DEFAULT cAlias TO ALIAS()

   DO WHILE nWaitTine > 0
      IF &cAlias->( DBRLOCK( nRecord ) )
         lRet := .T.
         EXIT
      ELSE
         DBRUNLOCK( nRecord )
         hb_idleSleep( 0.1 )
         nWaitTine -= 0.1
      ENDIF
   ENDDO
RETURN lRet

*+--------------------------------------------------------------------
*+
*+    Function Net_Append()
*+
*+    Called from ( dlforum.prg )   1 - static procedure doendmsg()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Net_Append( cAlias )

LOCAL nWaitTine := 3
LOCAL lRet      := .F.

   DEFAULT cAlias TO ALIAS()

   DO WHILE nWaitTine > 0
      &cAlias->( DBAPPEND() )

      IF NETERR()
         hb_idleSleep( 0.1 )
         nWaitTine -= 0.1
      ELSE
         lRet := .T.
         EXIT
      ENDIF
   ENDDO
RETURN lRet

*+--------------------------------------------------------------------
*+
*+    Function Net_Use()
*+
*+    Called from ( color.prg )   1 - procedure setup_color()
*+                ( dlforum.prg )   1 - procedure dofillhtmlsign()
*+                ( editdbf.prg )   1 - procedure edit_phpbb()
*+                                   1 - procedure edit_htmlsign()
*+                                   1 - procedure edit_user()
*+                ( forumhmg.prg )   3 - procedure main()
*+                                   1 - static procedure createindex()
*+                                   1 - static procedure createforumdbf()
*+                                   1 - static procedure createstriphtml()
*+                                   1 - static procedure createcolor()
*+                                   2 - static procedure checkdbf()
*+                                   2 - static procedure checkforumdir()
*+                                   1 - static procedure fillcomboforum()
*+                                   2 - static procedure docleanbody()
*+                                   2 - static procedure dochangeforum()
*+                ( setfilter.prg )   1 - procedure fillnotuser()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Net_Use( cFile_dbf, lExclusive, cAlias )

LOCAL nWaitTine := 3
LOCAL lRet      := .F.
LOCAL oError, cText
LOCAL bOldError := ERRORBLOCK( { | e | BREAK( e ) } )

   DEFAULT lExclusive TO .F.

   DO WHILE .T.
      IF FILE( cFile_dbf )
         DO WHILE nWaitTine > 0

            BEGIN SEQUENCE
               IF lExclusive
                  IF EMPTY( cAlias )
                     USE (cFile_dbf) EXCLUSIVE VIA "DBFCDX"
                  ELSE
                     USE (cFile_dbf) EXCLUSIVE ALIAS (cAlias) VIA "DBFCDX"
                  ENDIF
               ELSE
                  IF EMPTY( cAlias )
                     USE (cFile_dbf) VIA "DBFCDX"
                  ELSE
                     USE (cFile_dbf) ALIAS (cAlias) VIA "DBFCDX"
                  ENDIF
               ENDIF

            RECOVER USING oError
               ERRORBLOCK( bOldError )
               IF oError:osCode = 32
                  cText := "Error : " + oError:description + CRLF
                  cText += "Operation : " + oError:operation + CRLF
                  cText += CRLF
                  cText += "FORUMHMG.exe seems to be still active" + CRLF
                  cText += "start Taskmanager and terminate FORUMHMG.exe"

                  MsgInfo( cText, "Error create DBF" )
                  RETURN ( .F. )
               ENDIF
            END SEQUENCE
            ERRORBLOCK( bOldError )

            IF .NOT. NETERR()
               RETURN ( .T. )
            ENDIF

            hb_idleSleep( 0.1 )
            nWaitTine -= 0.1
         ENDDO
      ELSE
         MsgInfo( cFile_dbf + " not found" )
         RETURN ( .F. )
      ENDIF
   ENDDO

   IF nWaitTine > 0
      lRet := .T.
   ELSE
      MsgInfo( "Timeout file " + cFile_dbf )
   ENDIF

RETURN lRet

*+--------------------------------------------------------------------
*+
*+    Function IsInternet()
*+
*+    Called from ( dlallcod.prg )   1 - procedure downloadrenewcode()
*+                                   1 - static procedure newfwcode()
*+                ( dlrange.prg )   1 - procedure downloadrange()
*+                ( forumhmg.prg )   1 - procedure main()
*+                                   1 - procedure dorenewmsg()
*+                ( translat.prg )   1 - procedure translatememoform()
*+
*+--------------------------------------------------------------------
*+
FUNCTION IsInternet()

LOCAL xerrdescription, xurl := "www.google.com"
LOCAL lRet            := .F.

   xerrdescription := HB_PING( xurl )
   DO CASE
      CASE xerrdescription = 0
         //  MSGINFO("Ping to " + xurl + " Succesful", "Internet Connection Available")
         lRet := .T.
      CASE xerrdescription = 11001
         MSGINFO( "The reply buffer was too small." )
      CASE xerrdescription = 11002
         MSGINFO( "The destination network was unreachable." )
      CASE xerrdescription = 11003
         MSGINFO( "The destination host was unreachable." )
      CASE xerrdescription = 11004
         MSGINFO( "The destination protocol was unreachable." )
      CASE xerrdescription = 11005
         MSGINFO( "The destination port was unreachable." )
      CASE xerrdescription = 11006
         MSGINFO( "Insufficient IP resources were available." )
      CASE xerrdescription = 11007
         MSGINFO( "A bad IP option was specified." )
      CASE xerrdescription = 11008
         MSGINFO( "A hardware error occurred." )
      CASE xerrdescription = 11009
         MSGINFO( "The packet was too big." )
      CASE xerrdescription = 11010
         MSGINFO( "The request timed out." + HB_OSNEWLINE() + "Internet Connection Not Available" )
      CASE xerrdescription = 11011
         MSGINFO( "A bad request." )
      CASE xerrdescription = 11012
         MSGINFO( "A bad route." )
      CASE xerrdescription = 11013
         MSGINFO( "The time to live (TTL) expired in transit." )
      CASE xerrdescription = 11014
         MSGINFO( "The time to live expired during fragment reassembly." )
      CASE xerrdescription = 11015
         MSGINFO( "A parameter problem." )
      CASE xerrdescription = 11016
         MSGINFO( "Datagrams are arriving too fast to be processed" + HB_OSNEWLINE() + ;
                  " and datagrams may have been discarded." )
      CASE xerrdescription = 11017
         MSGINFO( "An IP option was too big." )
      CASE xerrdescription = 11018
         MSGINFO( "A bad destination." )
      CASE xerrdescription = 11050
         MSGINFO( "A general failure" + HB_OSNEWLINE() + ;
                  "This error can be returned for some malformed ICMP packets." )
      OTHERWISE
         MSGINFO( "Internet Connection Not Available" )
   ENDCASE
RETURN lRet

//
//
//

*+ EOF: FORUMHMG.PRG